<template>
	<AbsoluteLayout height="100%">
		<OptionButton top="4" ref="opButton" :marginLeft="widthDIPs-50" @listado="$emit('listado')" :id="item.id" tipo='5' color="#ccbe00e6" class="fa" :title="'\uf030'" />
		<OptionButton v-show="user.role == 3" top="4" :marginLeft="widthDIPs-50" @listado="$emit('listado')" :id="item.id" tipo='4' color="#ff8000" title="E" :tipo_a="item.tipo_a" :actividad_id="item.actividad_id" />
        <OptionButton v-show="user.role == 3" top="4" :marginLeft="widthDIPs-50" @listado="$emit('listado')" :id="item.id" tipo='3' color="#00bfff" title="T" />
        <OptionButton v-show="user.role == 4" top="4" :marginLeft="widthDIPs-50" @listado="$emit('listado')" :id="item.id" tipo='2' color="#006600" title="A" /> 
        <OptionButton v-show="user.role == 4" top="4" :marginLeft="widthDIPs-50" @listado="$emit('listado')" :id="item.id" tipo='1' color="#ff0000" title="N" />

		<StackLayout :marginLeft="widthDIPs-50" ref="menButton" :isEnabled="isEnabled" class="fab-button" :class="classBack" @tap="buttonMenuTap">
			<GridLayout rows="2, auto" horizontalAlignment="center" class="fab-icon" :class="buttonAnimation">
				<Label row="1" v-if="isEnabled" class="fab-dash--1" :class="classBack_p"/>
				<Label row="1" :class="classBack_p"/>
			</GridLayout>
		</StackLayout>
	</AbsoluteLayout>
</template>


<script>
import OptionButton from './OptionButton';
import axios from 'axios';
import store from '../../store';
import { urlApi } from '../../main.js';
import { screen } from "tns-core-modules/platform";

export default {
	props: ['item'],
	components:{ OptionButton },
	data(){
		return{
			widthDIPs: screen.mainScreen.widthDIPs
		}
	},
    computed: {
		buttonAnimation() {
			return this.isActive ? "iconActive" : "iconIdle"
		},
		classBack(){
			return this.isEnabled ? "backActived" : "backDesactived"
		},
		classBack_p(){
			return this.isEnabled ? "back_pActived" : "back_pDesactived"
		},
		isActive(){
			return store.getters.getIsActiveMenuButton(this.item.id) ? true:false;
		},
		isEnabled(){
			return store.getters.getIsEnabledMenuButton(this.item.id) ? true:false;
		},
		user(){
      return store.getters.getUser;
    }
	},    
    methods: {
		buttonMenuTap(){
			store.dispatch('setIsActiveMenuButton', this.item.id);
			console.log('item');
			
			if(this.isActive)
				this.getTrackingStatus();
		},
		getTrackingStatus(){
				axios.get(urlApi+`/api/v1/mtto/mantenimiento/logs/${this.item.id}/trackingStatus`)
				.then(respuesta=>{
					this.status = respuesta.data.status_id;
					console.log('status: ',this.status);

					store.dispatch('setIsEnabledOptionButton', {
						id: this.item.id,
						status: this.status
					});
				})
				.catch(error=>{
					console.log(error);
				});
			}
    }
}

</script>

<style scoped>

	.back_pActived{
		background-color: white;
		transform: rotate(90deg) translate(0, -2);
		height: 16;
		width: 3;
	}

	.back_pDesactived{
		background-color: red;
		transform: rotate(90deg) translate(0, -2);
		height: 16;
		width: 3;
	}

	.backActived{
		background-color: orangered;
		
	}

	.backDesactived{
		background-color: #1d1e23;
	}

	.fab-button {
		width: 50;
		height: 50;
		border-radius: 28;
		vertical-align: center;
	}

	.fab-icon {
		height: 16;
		width: 16;
	}

	.fab-dash--1,
	.fab-dash--2 {
		background-color: #fff;
		transform: translate(0, -2);
		height: 16;
		width: 3;
	}

	.iconActive {
		animation-name: iconActive;
		animation-duration: .25;
		animation-timing-function: cubic-bezier(0.165, 0.840, 0.440, 1.000);
		animation-fill-mode: forwards;
	}

	.iconIdle {
		animation-name: iconActive;
		animation-duration: .25;
		animation-timing-function: ease-out;
		animation-fill-mode: forwards;
		animation-direction: reverse;
	}

	@keyframes iconActive {
		from {
			transform: rotate(0deg);
		}
		to {
			transform: rotate(225deg);
		}
	}
</style>